
program BCHcode;

uses bchunit,crt;

const
  n=31;       {length of code word}
  r=10;       {degree of generator polynomial of cyclic code}
  d=5;        {min distance between code words}
  wg:array[0..r] of byte=(1,1, 1,0,1, 1,0,1, 0,0,1); { wg[0] - wspolczynnik przy najwyzszej potedze }
                          { 3      5      5      1 code generating polynomial}

type
  Code_Rest=array[0..r-1] of byte; {elements of syndrom}
  Code_Word=array[0..n-1] of byte; {elements of code word}

var
  F2,C:Code_Word;
  F3:Code_Rest;
  message,error:string;
  waga,h,i,k :byte;
  j:integer;

{---------------------------------------------------------------------------}
function Space( a:integer ):string;
begin
  if a>0 then begin
                dec(a);
                Space:=Space(a)+' ';
              end
         else Space:='';
end;
{---------------------------------------------------------------------------}


BEGIN
  Data(n,r,wg); { data for bchunit }
  TextAttr:=15;
  ClrScr;
  Writeln(' BCH CODE ');
  Writeln('Write message to send { ',n-r,' chars  "0" or "1" }');
  Write( '                MESSAGE : ');
  TextAttr:=16*5;
  Write(Space(n-r));
  GoToXY(27,WhereY);
  Readln(message);

  j:=length(message);
  if j<(n-r) then
  for i:=j+1 to n-r do message:=message + '0';

  for i:=0   to n-r-1  do val(message[i+1],F2[i],j);
  for i:=n-r to n-1    do F2[i] :=0;

  Calculate_Syndrom(F2,F3);
  for i:=n-r to n-1    do F2[i] :=F3[i-n+r];
  Writeln;
  TextAttr:=15;
  write('              CODE WORD : ');
  for i:=0 to n-1 do begin Write(F2[i]); C[i]:=F2[i]; end;

  Writeln; Writeln;
  Writeln('Write transmision error pattern');
  Write('                  ERROR : ');
  TextAttr:=16*6;
  Write(Space(n));

  GoToXY(27,WhereY);
  Readln(error);

  j:=length(error);
  if j<n then
  for i:=j+1 to n do error:=error + '0';


  for i:=0   to n-1  do begin
                          val(error[i+1],k,j);
                          F2[i]:=(F2[i]+k) mod 2;
                        end;

  TextAttr:=15;
  GoToXY(1,10);
  Write('           RECIVED WORD : ');
  for i:=0 to n-1 do Write(F2[i]);
  Writeln;

  waga:=0;
  Calculate_Syndrom(F2,F3);
  for i:=0 to r-1 do if F3[i]>0 then inc(waga);
  Write('SYNDROM OF RECIVED WORD : ');
  for i:=0 to r-1 do Write(F3[i]);
  Writeln;
  Writeln('      WEIGHT OF SYNDROM : ',waga);

  if waga<=(d-1) div 2
            then begin
                   Writeln;
                   TextAttr:=14;
                   writeln('No error in information part of code word.');
                   Writeln('No corection is needed.');
                 end
            else begin
                   TextAttr:=12;
                   Writeln('Some errors in information part of code word !');
                   Writeln('Begining corection process.');
                   TextAttr:=15;
                   repeat     { shift right }
                     inc(h);
                     k:=F2[n-1];
                     for i:=n-2 downto 0 do F2[i+1]:=F2[i];
                     F2[0]:=k;
                     GoToXY(1,16);
                     Write('      SHIFTED CODE WORD : ');
                     for i:=0 to n-1 do Write(F2[i]);
                     Writeln;
                     waga:=0;
                     Calculate_Syndrom(F2,F3);
                     for i:=0 to r-1 do if F3[i]>0 then inc(waga);
                     Write('                SYNDROM : ');
                     for i:=0 to r-1 do Write(F3[i]);
                     Writeln;
                     Write('      WEIGHT OF SYNDROM :     ');
                     GoToXY(Wherex-4,WhereY);
                     Writeln(waga);
                     Writeln('Press Enter to next step !');
                     repeat until readkey=#13 ;
                 until (waga<=(d-1) div 2) or (h>(n-r));

                 Writeln;
                 TextAttr:=14;

                 if (waga <= (d-1) div 2) then begin
                                    for i:=n-r to n-1  do
                                      F2[i]:=(F2[i]+F3[i-n+r]) mod 2;

                                    repeat    { shift right n-h positions = shift left h positions }
                                      inc(h);
                                      k:=F2[n-1];
                                      for i:=n-2 downto 0 do F2[i+1]:=F2[i];
                                      F2[0]:=k;
                                    until h=N;

                                    writeln('End of corection process.');
                                    write('        CORECT CODE WORD : ');
                                    for i:=0 to n-1 do Write(F2[i]);
                                    Writeln;
                                    write('      RECEIVED CODE WORD : ');
                                    for i:=0 to n-1 do Write(C[i]);
                                    Writeln;
                                  end
                             else
                                  writeln('No corectable error pattern !');

                 end;

  TextAttr:=15;
  Writeln;
  writeln( 'End of the program press Esc to quit.');
  repeat until readkey=#27;
END.
